	LIST p=16f84a
	#include<p16f84.inc>
	;3FF1

#define  row1	PORTB,4
#define  row2	PORTB,5
#define  row3	PORTB,6
#define  row4	PORTB,7
#define	 out	PORTA,0
#define	 led	PORTA,1
bitk	equ	d'50'	
klava	equ	PORTB
;delc	equ	h'c'
;deld	equ	h'd'
;dele	equ	h'e'
cols	equ	h'10
key	equ	h'11'
index	equ	h'12'
delcon  equ	h'13'
bitcon  equ	h'14'
msgcon	equ	h'15'
xmtbit	equ	h'16'

start	bsf	STATUS,RP0
	movlw	 b'11111000'
	movwf	TRISB
	clrf	TRISA
	bcf	STATUS,RP0
	clrf	PORTB
keys	call	scanke
	movlw  h'd'
	subwf  key,0
	btfsc  STATUS,Z
	goto   delay
	bsf	led
	movf  key,0
again	movlw	h'8'
	movwf	bitcon
	movf	key,0
	call	string
	movwf	xmtbit
	bcf	out
	call	bitdel
xmit	rrf	xmtbit
	btfss	STATUS,C
	bcf	out
	btfsc	STATUS,C
	bsf	out
	call	bitdel
	decfsz	bitcon,1
	goto	xmit
	bsf	out
	call	bitdel
	call	bitdel
	call	bitdel
	call	bitdel
	call	bitdel
	call	bitdel
	bcf	led
	goto	keys
bitdel	movlw	bitk
	movwf	delcon
loop	nop
	decfsz	delcon,1
	goto	loop
	retlw	0
string	addwf	PCL,1
	nop
	retlw	h'33'	;3
	retlw	h'36'	;6
	retlw	h'39'	;9
	retlw	h'23'	;#
	retlw	h'32'	;2
	retlw	h'35'	;5
	retlw	h'38'	;8
	retlw	h'30'	;0
	retlw	h'31'	;1
	retlw	h'34'	;4
	retlw	h'37'	;7
	retlw	h'2a'	;*
	
delay	nop
	nop
	decfsz	index
	goto	delay		
	goto  keys
scanke      clrf key
	bsf  key,0
	clrf klava
	movlw h'3'
	movwf cols
	bsf  STATUS,C
scan	rlf  klava
	bcf  STATUS,C
	btfsc row1
	goto  pres
	incf  key
	btfsc row2
	goto  pres
	incf  key
	btfsc row3
	goto  pres
	incf  key
	btfsc row4
	goto  pres
	incf  key
	decfsz cols
	goto  scan
pres	retlw 0
	end

